unit controlUnit;
{
 hold settings / selections
 handle events
}
interface

uses windows,forms,controls,graphics,classes,dav7components,Xbitmap,dialogs,
     sysutils;

type Tmainbutton = (mbClear,mbClip,mbDot,mbline,mbEllipse,mbArc,
                    mbRect,mbFill,mbPolygon,mbPicture,mbHelp,mbOff);
     TmouseEvent = (meDown,meUp,meMove);

const bgColor = $e3ffff;   //level 3
      gridColor = $d3d3d3; //level 3      

var mainbutton : TMainbutton = mbOff;
    mouseEvent : TmouseEvent;
    mouseX,mouseY : integer;

    var bm : TXBitmap;//for pictures

//--- global properties -------

    pencolor : DWORD = $0;
    penwidth : byte = 1;
    penlevel : byte = 0;
    linestyle : byte = 0;
    ArrowCode : byte = 0;
    brushcolor : DWORD = $ffffff;
    brushlevel : byte = 3;
    brushFlag : boolean  = true;
    fillsize : TXFillmapsize = fms8;
    fillstyle : byte = 0;
    stretchmode : TXstretchmode = smFullSource;
    radius : byte = 0;

//-- rects

    clipping : boolean = false; //if cliprect active
    fullmaprect : Trect;
    maprect : Trect;            //loaded into cliprect on draw op.

procedure frame(c : TControl);
procedure mouseProc;
procedure polygonProc;
procedure rectproc;
procedure PictureProc;
procedure startdraw;
procedure startclip;
procedure clearmaps;

implementation

uses unit1;

const poly : array[0..15] of TPoint =
             ((x: 50; y:250),(x:100; y:200),(x:100;y:150),(x:200;y:175),
              (x:250; y: 50),(x:300; y:125),(x:350;y:150),(x:400;y:220),
              (x:450; y:250),(x:450; y:300),(x:300;y:350),(x:300;y:400),
              (x:250; y:450),(x:200; y:420),(x:150;y:350),(x:150;y:300));
      clipcolor = $ff00ff;

var px1,px2,py1,py2,px3,py3,px4,py4 : integer;  //from mouse events
    d_count : byte = 0;
    map1rect : Trect;
    map2rect : Trect;
    map2full : boolean = false;  //if rectangle active in map2

procedure drawprocswitch(bm : TXbitmap);forward;
procedure dotproc;forward;
procedure polygonEventproc;forward;
procedure pictureEventproc;forward;
procedure paintcliprect;forward;
procedure setxmap(bm : TXBitmap);forward;
procedure floodfillproc;forward;
procedure clipproc;forward;
procedure arcProc;forward;
procedure setclipPropsMap2;forward;
procedure map12box;forward;
procedure map2box;forward;
procedure clearmap1;forward;

procedure startdraw;
//initiate drawing of line, ellipse
begin
 d_count := 0;
end;

procedure startclip;
//initialize drawing of clip rectangle
begin
 d_count := 0;
 if clipping then
  begin
   clipping := false;
   map1.XClipRect := fullmaprect;
   map2rect := fullmaprect;
   maprect := fullmaprect;
   map12box;
  end;
end;

procedure mouseProc;
//all mouse events pass here
begin
 case mainbutton of
  mbDot      : if mouseEvent = meDown then dotproc;
  mbline,
  mbEllipse,
  mbRect     : rectproc; //line,ellipse,rectangle
  mbClip     : clipproc;
  mbArc      : arcproc;
  mbFill     : if mouseEvent = meDown then
                begin
                 floodfillproc;
                 form1.mainbtn.BtnRelease(byte(mainbutton));
                end;
  mbPolygon  : polygonEventproc;//changes of shape
  mbPicture  : pictureEventproc;
 end;//case
end;

procedure map12;
//restore rect of map2 from map1
begin
 if map2full then map2rect := Unirect(map2rect,map1rect)
  else map2rect := map1rect;
 map2.Canvas.CopyRect(map1rect,map1.canvas,map1rect);
 map2full := true;
end;

procedure map2box;
//copy map2 rect d_rect to paintbox
begin
 if clipping then paintcliprect;//in map2
 form1.paintbox1.Canvas.CopyRect(map2rect,map2.canvas,map2rect);
 map2full := false;
end;

procedure map12box;
//d_rect from map1 to map2 to paintbox
begin
 map12;
 map2box;
end;

procedure UpdateMap2Rect(r : Trect);
//if boxflag = false, set true, map2rect = r
//if boxflag = true , set map2rect to union of map2rect , r
begin
 if map2full then map2rect := UniRect(map2rect,r)
  else begin
        map2Rect := r;
        map2full := true;
       end;
end;

//---- draw procedures

procedure dotproc;
//paint a dot
begin
 with map1 do
  begin
   Xpenlevel := penlevel;
   Xpenwidth := penwidth;
   XpenColor := pencolor;
   if clipping then XclipRect := maprect;
   Xdot(mouseX,mouseY);
   map1rect := Xmodrect;
  end;
 map12box;
end;

procedure rectproc;
//draw rectangle, line, ellipse, cliprect
//d_count is control counter
begin
 case mouseEvent of
   meDown : if d_count = 0 then             //if idle
             begin
              d_count := 1;                 //mark start
              px1 := mouseX; py1 := mouseY;
              setXmap(map2);                //set properties
             end;
   meMove : if (d_count = 1) or (d_count = 2) then
             begin
              if d_count = 2 then map12; //if drawing,clear old image
              px2 := mouseX; py2 := mouseY;
              drawprocswitch(map2);
              map1rect := map2.XModRect;
              UpdateMap2Rect(map1rect);
              map2box;
              d_count := 2;
            end;
   meUp   : begin
             if d_count = 2 then
              begin
               d_count := 3;
               setXmap(map1);
               drawprocswitch(map1);
               map12box;
              end;
             d_count := 0;
            end;
 end;//case
end;

procedure clipproc;
//draw clipping
//d_count is control counter
begin
 case mouseEvent of
   meDown : if d_count = 0 then             //if idle
             begin
              d_count := 1;                 //mark start
              px1 := mouseX; py1 := mouseY;
              clipping := false;
              maprect := fullmaprect;
              map1rect := fullmaprect;
              map1.XClipRect := maprect;
              setclipPropsMap2;
              map12box;                      //remove old cliprect in map2
             end;
   meMove : if (d_count = 1) or (d_count = 2) then
             begin
              if d_count = 2 then map12; //if drawing
              px2 := mouseX; py2 := mouseY;
              map2.Canvas.Rectangle(px1,py1,px2,py2);
              map1rect := packrect(px1,py1,px2,py2);
              UpdateMap2Rect(map1rect);
              map2box;
              d_count := 2;
            end;
   meUp   : begin
             if d_count = 2 then
              begin
               d_count := 3;
               maprect := PackRect(px1,py1,px2,py2);
               clipping := true;
              end;
             form1.mainbtn.BtnRelease(byte(mainbutton));
             mainbutton := mbOff;
             d_count := 0;
            end;
 end;//case
end;

procedure polygonproc;
//make polygon;
begin
 with map1 do
  begin
   Xpencolor := pencolor;
   Xpenlevel := penlevel;
   XpenWidth := penwidth;
   XbrushColor := brushcolor;
   XUsebrush := brushFlag;
   Xbrushlevel := brushlevel;
   if clipping then map1.XClipRect := maprect
    else map1.XCliprect := fullmaprect;
   Xpolygon(poly);
   map1rect := maprect;
   map12box;
  end;
end;

procedure floodfillproc;
begin
 with map1 do
  begin
   XfillStyle := fillstyle;
   XFillMapSize := fillsize;
   XClipRect := maprect;
   XbrushColor := brushcolor;
   Xbrushlevel := brushlevel;
   Xfloodfill(mouseX,mouseY);
  end;
 map1rect := maprect;
 map12box;
end;

procedure PictureProc;
//load a picture in XCliprect of map1
begin
 with form1 do
  begin
   if clipping then map1.xcliprect := maprect
    else map1.xcliprect := fullmaprect;
   map1rect := map1.XClipRect;
   if stretchgroup.itemindex = 0 then map1.xstretchmode := smFullSource
    else map1.xstretchmode := smfullDest;
   if opendialog1.execute then
    begin
     if bm = nil then bm := TXBitmap.create;
     bm.loadfromfile(opendialog1.filename);
     bm.XAdjust;
     map1.XstretchRect(map1.Xcliprect,bm,rect(0,0,bm.width,bm.height));
     map12box;
    end;
  end;//with
end;

procedure arcProc;
//draw Arc

const mx : integer = 0;
      my : integer = 0;
var r : Trect;

   procedure tempclear; //reset map2 temp drawing
   begin
    map12;
   end;

   procedure fixR(var rr : Trect);//add penwidth to rect
   begin
    with rr do
     begin
      left := left-penwidth; right := right + penwidth;
      top := top - penwidth; bottom := bottom + penwidth;
     end;
   end;

   procedure tempdraw(x,y : integer); //draw ellipse, line in map2
   begin                              //for arc selection
    with map2.canvas do
     begin
      pen.width := penwidth;
      pen.color := $c0c0c0;
      ellipse(px1,py1,px2,py2);
      r := packrect(px1,py1,px2,py2);
      fixR(r);
      map1rect := r;
      updatemap2rect(r);
      pen.width := 1;
      moveto(mx,my); lineto(x,y);
      r := packrect(mx,my,x,y);
      fixR(r);
      map1rect := unirect(map1rect,r);//holds rect of new drawing
      updatemap2rect(r);
     end;
   end;

begin
 case mouseEvent of
  meDown :

      case d_count of
       0,1,2 : rectproc;      //start drawing ellipse
           4 : begin
                px4 := mouseX; py4 := mouseY;
                tempclear;
                tempdraw(px4,py4);
                map2.Xarc(px1,py1,px2,py2,px3,py3,px4,py4);
                updatemap2rect(map2.Xmodrect);
                map1rect := map2rect;
                map2box;
                d_count := 5;  //draw temp. arc
               end;
      end;//case

  meMove :

      case d_count of
         0,2 : rectproc;     //draw ellipse
           1 : begin
                map2.XUseBrush := false;   //no filling
                map2.canvas.brush.style := bsClear;
                rectproc;
               end;
           3 : begin
                px3 := mouseX; py3 := mouseY;
                tempdraw(px3,py3);
                d_count := 4;
               end;
           4 : begin
                px3 := mouseX; py3 := mouseY;
                tempclear;
                tempdraw(px3,py3);
                map2box;
               end;
           5 : begin
                px4 := mouseX; py4 := mouseY;
                tempclear;
                tempdraw(px4,py4);
                map2.Xarc(px1,py1,px2,py2,px3,py3,px4,py4);
                r := map2.XModRect;
                updatemap2rect(r);
                map1rect := unirect(map1rect,r);
                map2box;
               end;
      end;//case

  meUp :

      case d_count of
       2 : begin
            d_count := 3;
            mx := trunc((px1 + px2) div 2);
            my := trunc((py1 + py2) div 2);
           end;
       5 : begin
            d_count := 6;
            tempclear;
            setXmap(map1);   //load properties
            map1.Xarc(px1,py1,px2,py2,px3,py3,px4,py4);
            updatemap2rect(map1.XmodRect);
            map1rect := unirect(map1rect,map2rect);
            map12box;
            d_count := 0;
           end;
      end;//case

 end;//case
end;

//--------- support -------------

procedure drawmap2Rect(Arect : trect);
//draw rect on polygon point in map2, copy to paintbox
begin
 with map2.canvas do
  begin
   pen.color := $ff00ff;
   pen.width := 2;
   brush.style := bsClear;
   with Arect do
    begin
     rectangle(left+1,top+1,right-1,bottom-1);
    end;
   map2rect := Arect;
   map2box;
  end;
end;

procedure polygonEventproc;
//change of polygon
const oldNr : byte = 0;
      oldHit : boolean = false;
      hit : boolean = false;
      Arect : Trect = (left:0; top: 0; right: 0; bottom: 0);
var i : byte;
begin
 case mouseEvent of
  meMove : begin
            if (d_count = 0) then
             begin
              i := 0;//0
              repeat
               hit := (abs(mouseX - poly[i].x) < 5) and
                      (abs(mouseY - poly[i].y) < 5);
               if hit = false then inc(i);
              until hit or (i > high(poly));
              if hit and (oldhit=false) then
               begin
                with Arect do begin
                               left := poly[i].x - 5;
                               right := poly[i].x + 5;
                               top := poly[i].y - 5;
                               bottom := poly[i].y + 5;
                              end;
                oldNr := i;
                drawmap2Rect(Arect);//also to paintbox
               end;
              if (hit=false) and oldhit then
               begin
                map2rect := Arect;
                map12box;
               end;
              oldhit := hit;
             end;

             if (d_count = 1) then
              begin
               poly[oldNr].x := mouseX;
               poly[oldNr].y := mouseY;
               clearmap1;
               polygonProc;
              end;
           end;
  meDown : if hit then d_count := 1;
  meUp   : d_count := 0;
 end;//case
end;

procedure PictureEventproc;
//change of polygon
const oldhitcode : byte = 0;
      Arect : Trect = (left:0; top: 0; right: 0; bottom: 0);
var hitcode : byte;

    procedure clearA;//remove Arect from map2
    begin
     map1rect := Arect;
     map12box;
    end;

    procedure writeA;//write Arect to map2, copy to box
    begin
     with map2 do with canvas do
      begin
       brush.style := bsclear;
       pen.color := $ff00ff;
       pen.Width := 1;
       with Arect do
        begin
         left := mousex - 5; right := mouseX + 5;
         top := mouseY - 5; bottom := mouseY + 5;
        end;
       rectangle(Arect.left,Arect.top,Arect.right,Arect.bottom);
       updateMap2Rect(Arect);
       map2box;
      end;
    end;

    procedure makehitcode;
    begin
     hitcode := 0;
     if abs(mouseX - maprect.left) < 5 then hitcode := 1;
     if abs(mouseY - maprect.top)  < 5 then hitcode := hitcode or 2;
     if abs(mouseX - maprect.right)< 5 then hitcode := hitcode or 4;
     if abs(mouseY - maprect.bottom)< 5 then hitcode := hitcode or 8;
     if hitcode mod 3 = 0 then hitcode := hitcode div 3
      else hitcode := 0;
    end;

//------------ main ---------

begin
 if assigned(bm) = false then exit;
 case mouseEvent of meMove :
   begin
    if (d_count = 0) then       //moving mouse over screen
     begin
       makehitcode;
       if hitcode <> oldhitcode then
        begin
         clearA;
         if hitcode <> 0 then writeA;
        end;
       oldhitcode := hitcode;
     end;//if d_count = 0

    if (d_count = 1) then
     begin
      if oldhitcode <> 0 then clearA;
      updatemap2rect(maprect);
      case oldhitcode of
       1 : begin
            if mouseX < maprect.right-10 then maprect.left := mouseX;
            if mouseY < maprect.bottom - 10 then maprect.top := mouseY;
           end;
       2 : begin
            if mouseX > maprect.left + 10 then maprect.right := mouseX;
            if mouseY < maprect.bottom - 10 then maprect.top := mouseY;
           end;
       3 : begin
            if mouseX < maprect.right-10 then maprect.left := mouseX;
            if mouseY > maprect.top + 10 then maprect.bottom := mouseY;
           end;
       4 : begin
            if mouseX > maprect.left + 10 then maprect.right := mouseX;
            if mouseY > maprect.top + 10 then maprect.bottom := mouseY;
           end;
      end;//case

      clearmap1;
      if form1.stretchgroup.itemindex = 0 then map1.xstretchmode := smFullSource
       else map1.xstretchmode := smfullDest;
      map1.Xstretchrect(maprect,bm,rect(0,0,bm.width,bm.height));
      updatemap2rect(maprect);
      map1rect := map2rect;
      map12box;
     end;//if d_count = 1
   end;//case meMove

  meDown : if oldhitcode <> 0 then d_count := 1;

  meUp   : d_count := 0;

 end;//case mouseevent
end;

procedure setXmap(bm : TXbitmap);
//set bitmap bm properties
begin
 with bm do
  begin
   xpencolor := pencolor;
   xpenlevel := penlevel;
   xpenwidth := penwidth;
   xpencolor := pencolor;
   xpenlevel := penlevel;
   xpenwidth := penwidth;
   xbrushcolor := brushcolor;
   xbrushlevel := brushlevel;
   xusebrush := brushflag;
   xlinestyle := linestyle;
   xarrowcode := arrowcode;
  end;
 if clipping then map1.XClipRect := maprect
  else map1.Xcliprect := fullmaprect;
end;

procedure setclipPropsmap2;
//set map2 properties for painting of cliprect
begin
 with map2.canvas do
  begin
   pen.color := clipcolor;
   pen.width := 1;
   brush.Style := bsClear;
  end;
end;

procedure drawprocswitch(bm : TXbitmap);
//select drawing procedure
begin
 with bm do
  case mainbutton of
   mbLine    : Xline(px1,py1,px2,py2);
   mbEllipse,
   mbArc     : Xellipse(px1,py1,px2,py2);
   mbRect    : Xfillrect(px1,py1,px2,py2,radius);
  end;//case
end;

procedure paintcliprect;
//called if clipping 
//in map2
begin
 with map2.canvas do
  begin
   pen.color := clipcolor;
   pen.width := 1;
   brush.Style := bsclear;
   with maprect do rectangle(left,top,right,bottom);
  end;//with
end;

procedure frame(c : TControl);
//paint edge on parent canvas, around TControl
var pp : TCustomForm;
    x1,y1,x2,y2 : integer;
    i : byte;
begin
 pp := getParentForm(c);
 with pp do
  begin
   x1 := c.left-2;
   y1 := c.top-2;
   x2 := c.left+c.width+1;
   y2 := c.top+c.height+1;
  end;
  with pp.canvas do
   for i := 0 to 1 do
    begin
     moveto(x2-i,y1+i);
     pen.color := $0;
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.color := $a0a0a0;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
end;

procedure clearmap1;
//clear , paint grid
var i : byte;
begin
 with map1 do with canvas do
  begin
   XCliprect := fullmapRect; 
   brush.color := bgColor;
   brush.Style := bsSolid;
   fillrect(fullmapRect);
   Xpencolor := gridColor;
   XpenLevel := 3;
   Xpenwidth := 1;
   Xlinestyle := 0;
   XArrowCode := 0;
   for i := 0 to height div 20 do Xline(0,i*20,width-1,i*20);
   for i := 0 to width div 20 do Xline(i*20,0,i*20,height-1);
  end;
end;

procedure clearmaps;
begin
 clearmap1;
 map2.canvas.draw(0,0,map1);
 form1.paintbox1.invalidate;
end;

end.
